function love.load()
	balls = {{400,300}, {400,300}, {400,300}}
	effect = love.graphics.newPixelEffect [[
		extern vec2[3] balls;

		float metaball(vec2 x, vec2 c)
		{
			return 1.0 / dot(x-c, x-c);
		}

		vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
		{
			float d = metaball(pc, balls[0]) + metaball(pc, balls[1]) + metaball(pc, balls[2]);
			if (d <= .0007)
				return vec4(1.0);
			return vec4(0.0);
		}
	]]

	effect:send('balls', unpack(balls))
end

function love.draw()
	love.graphics.setPixelEffect(effect)

	love.graphics.rectangle('fill', 0,0,love.graphics.getWidth(), love.graphics.getHeight())
end

t = 0
function love.update(dt)
	t = t + dt
	balls[1] = {love.mouse.getX(), love.graphics.getHeight() - love.mouse.getY()}
	balls[2] = {math.sin(2*t) * 120 + love.graphics.getWidth()/2, math.cos(t) * 120 + love.graphics.getHeight()/2}
	balls[3] = {math.sin(t) * 120 + love.graphics.getWidth()/2, math.cos(2*t) * 120 + love.graphics.getHeight()/2}
	effect:send('balls', unpack(balls))
end
